;;textures init.lisp

(setq *compile-verbose* nil)
(defvar *debug* nil)

(defparameter *declarations* 
      '(*function-details* *basic-format* *introduction* *perform-error* midi default-instrument csound-score
        plain-event-list event-list testtracks *function-error* phrase *error-vars* *buffers* *ramp-types* piano cello
        vibraphone marimba pitched-percussion non-pitched-percussion clarinet piccolo flute contra-bass viola violin                   
        *utility-error* *phrases* pch-c4 midi-c4 *average-resolution* num-attacks *error* *tempo* *control-functions*                   
        *macro-functions* *buffer-ref* *buffer-hash* *runtime-errors* name cur-phrase *functions-list*                   
        *non-lisp-functions-list* instrument *function-keys* print-next-dot cur-beat))

(mapcar #'eval (mapcar #'(lambda (x) `(defvar ,x)) *declarations*))


(defparameter *windows-directory* "C:\\lisp\\textures\\")
(defparameter *mac-direcotry* "ccl:textures;")
(defparameter *file-names* '(utilities instrument-definitions instrument-macros main-functions
                                       sequencer genetic ramp-functions saveeventsasmidi
                                       performance documentation morph))

(let ((filesystem (machine-type)))
  (cond ((equal filesystem "x86")
         (mapcar (lambda (x)
                   (let ((filename (concatenate 'string 
                                     *windows-directory*
                                     (princ-to-string x)
                                     ".lisp")))
                     (eval `(load (compile-file ,filename)))))
           *file-names*)
         (format t "~%*****************************************************************************************************
There is a weird bug in ACL whereby it is necessary to re-load the utilities.lisp file (location loop 
doesn't work right).  Please open the file utilities.lisp, select all and compile (ctrl-d).
*****************************************************************************************************~%"))
          ((equal filesystem "  Power Macintosh")
           (setq *print-pretty* t)
           (setq *MINIMUM-STACK-OVERFLOW-SIZE* 2048000)
           (mapcar (lambda (x)
                     (let ((filename (concatenate 'string
                                       *mac-directory*
                                       (princ-to-string x)
                                       ".lisp")))
                       (eval `(load (mac-namestring ,filename)))))
             *file-names*))))




