;;;Copyright (c) 2001  Soren Goodman
;;;algnalogthmic music generator
;;;See readme.txt for details
;;;This file contains a list and documentation for the instrument macros 

#|

SEQUENCER-VARIATION-VARIATION
VARIATION-SPLIT
VARIATION-VARIATION
CHANCE-PICKONE
CHANCE-SPLIT 
CHANCE-RANDOM 
CHANCE-VARIATION
SEQUENCER-CHANCE-VARIATION


(SEQUENCER-CHANCE-VARIATION
    (&key (type 'cycle)(cycles '1)(motion 'forward)(reset-location nil)(start-pos 0)
      (max-r1 '(1))(min-r1 '(0))(chance-r1 '(.2))(erratic-r1 '(0))
      (max-r2 '(1))(min-r2 '(0))(chance-r2 '(.2))(erratic-r2 '(0))
      (melody '(8.0))(last-n nil)(first-n nil)(transpose 0)
      (chance-p '(.2))(max-p '(2))(min-p '(-2))(vary-p 't) 
      (max-d1 '(4))(min-d1 '(0))(chance-d1 '(.3))(erratic-d1 '(0))
      (max-d2 '(4))(min-d2 '(0))(chance-d2 '(.3))(erratic-d2 '(0)))
  
  "SEQUENCER-CHANCE-VARIATION uses CHANCE sequenced between two positions for both rhythm and duration,
and transposed last-n first-n VARIATION for pitch."

(CHANCE-VARIATION 
    (&key (max-r '(1)) (min-r '(0)) (chance-r '(.2)) '(more-erratic-r '(0))
      (melody '(8.0))(last-n nil)(first-n nil)(transpose 0)
      (chance-p '(.2))(max-p '(2))(min-p '(-2))(vary-p 't)
      (max-d '(1)) (min-d '(0)) (chance-d '(.2)) '(more-erratic-d '(0)))
  "CHANCE-VARIATION uses CHANCE for both rhythm and duration, with VARIATION for pitch.  Multi-ramp'd"

(SEQUENCER-VARIATION-VARIATION
    (&key (type 'cycle)(cycles '1)(motion 'forward)(reset-location nil)(start-pos 0)
      (input-r1 '(1 1 1 1))(truncate1 '(8))(chance-r1 '(.2))(min-r1 '(-1))(max-r1 '(1))(vary-r1 t)
      (input-r2 '(1 1 1 1))(truncate2 '(8))(chance-r2 '(.2))(min-r2 '(-1))(max-r2 '(1))(vary-r2 t)
      (melody '(8.0))(last-n nil)(first-n nil)(transpose 0)
      (chance-p '(.2))(max-p '(2))(min-p '(-2))(vary-p 't) 
      (max-d1 '(4))(min-d1 '(0))(chance-d1 '(.3))(erratic-d1 '(0))
      (max-d2 '(4))(min-d2 '(0))(chance-d2 '(.3))(erratic-d2 '(0)))
  
  "This macro uses VARIATION for rhythm, SPLIT-LIST for melody and CHANCE for duration.  The rhyhthm and
duration are step-sequenced between two sets, with each parameter multi-ramp'd within.  Reset-location
defaults to NIL for the sequencer (so the ramps are for the entire section, but there will be gaps when
the other part is playing...).
The melody is transposed and run through LAST-N then FIRST-N.  All single parameters multi-ramp'd."

(VARIATION-SPLIT
    (&key (input-r '(1 1 1 1))(truncate '(8))(chance-r '(.2))(min-r '(-1))(max-r '(1))(vary-r t)
          (first-n nil)(last-n nil)(melody '(6.01 6.03 6.04))(length t)(include nil)(transpose 0)
          (max-d '(4))(min-d '(0))(chance-d '(.3))(erratic-d '(0)))
  "This macro uses VARIATION for rhythm, SPLIT-LIST for melody and CHANCE for duration.
The melody is transposed and run through LAST-N then FIRST-N.  All non-list parameters
are multi-ramp'd."
 
(VARIATION-VARIATION
 (&key (input-r '(1 1 1 1))(chance-r '(.2))(min-r '(-1))(max-r '(1))(vary-r t)
   (first-n nil)(last-n nil)(melody '(6.01 6.03 6.04)) (chance-p '(.2))
   (max-p '(2))(min-p '(-2))(vary-p 't)(transpose '(0))
   (max-d '(4))(min-d '(0))(chance-d '(.3))(erratic-d '(0)))
 "This instrument uses the VARIATION function for both rhythm and pitch, and the chance function
for duration.  Most parameters are multi-ramp'd, the list for pitch goes through LAST-N then FIRST-N (in 
that order) before being inputed to the variation module."
 
 
(CHANCE-PICKONE
    (&key (melody '(7.0 7.01 7.03 7.04))(n '(4))(transpose '(0)) ;pitch
          (max-r '(1))(min-r '(0))(more-erratic-r '(1))(chance-r '(.5)) ;rhythm
          (max-d '(4))(min-d '(0))(more-erratic-d '(1))(chance-d '(.5)) ;duration
          (dynamics 127))
  "This instrument uses the chance function for both rhythm and duration and a 
transposed split-list for pitch.  All single parameters are multi-ramp'd."  
  
(CHANCE-SPLIT 
    (&key (melody '(7.0 7.01 7.03 7.04))(n '(4))(length '(3))(include '())(transpose '(0)) ;pitch
          (max-r '(1))(min-r '(0))(more-erratic-r '(0))(chance-r '(.5)) ;rhythm
          (max-d '(4))(min-d '(0))(more-erratic-d '(0))(chance-d '(.5)) ;duration
          (dynamics 127))
  "This instrument uses the chance function for both rhythm and duration and a 
transposed split-list for pitch.  All single parameters are multi-ramp'd."  
 
(CHANCE-RANDOM 
    (&key (pc-set '(0 1 3 4)) (range-lo '(6.04)) (range-hi '(9.07))(transpose '(0)) ;pitch
          (max-r '(1))(min-r '(0))(more-erratic-r '(1))(chance-r '(.5)) ;rhythm
          (max-d '(4))(min-d '(0))(more-erratic-d '(1))(chance-d '(.5)) ;duration
          (dynamics 127))
  "This instrument uses the chance function for both rhythm and duration and a 
transposed random-from-pc for pitch.  All single parameters are multi-ramp'd (i.e. not pc-set)."  
  
  
  
  
|#